#ifndef _H_472A1F6DDB85D4A0D3D0552C3B4ED1F3_LightSensors_DCPS_H_
#define _H_472A1F6DDB85D4A0D3D0552C3B4ED1F3_LightSensors_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LightSensors_.h"


namespace raspimouse_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LightSensors_TypeSupportInterface;

            typedef LightSensors_TypeSupportInterface * LightSensors_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LightSensors_TypeSupportInterface> LightSensors_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LightSensors_TypeSupportInterface> LightSensors_TypeSupportInterface_out;


            class LightSensors_DataWriter;

            typedef LightSensors_DataWriter * LightSensors_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LightSensors_DataWriter> LightSensors_DataWriter_var;
            typedef DDS_DCPSInterface_out < LightSensors_DataWriter> LightSensors_DataWriter_out;


            class LightSensors_DataReader;

            typedef LightSensors_DataReader * LightSensors_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LightSensors_DataReader> LightSensors_DataReader_var;
            typedef DDS_DCPSInterface_out < LightSensors_DataReader> LightSensors_DataReader_out;


            class LightSensors_DataReaderView;

            typedef LightSensors_DataReaderView * LightSensors_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LightSensors_DataReaderView> LightSensors_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LightSensors_DataReaderView> LightSensors_DataReaderView_out;

            struct LightSensors_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LightSensors_, struct LightSensors_Seq_uniq_> LightSensors_Seq;
            typedef DDS_DCPSSequence_var < LightSensors_Seq> LightSensors_Seq_var;
            typedef DDS_DCPSSequence_out < LightSensors_Seq> LightSensors_Seq_out;

            class  LightSensors_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LightSensors_TypeSupportInterface_ptr _ptr_type;
                typedef LightSensors_TypeSupportInterface_var _var_type;

                static LightSensors_TypeSupportInterface_ptr _duplicate (LightSensors_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LightSensors_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LightSensors_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LightSensors_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LightSensors_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LightSensors_TypeSupportInterface () {};
                ~LightSensors_TypeSupportInterface () {};
            private:
                LightSensors_TypeSupportInterface (const LightSensors_TypeSupportInterface &);
                LightSensors_TypeSupportInterface & operator = (const LightSensors_TypeSupportInterface &);
            };

            class  LightSensors_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LightSensors_DataWriter_ptr _ptr_type;
                typedef LightSensors_DataWriter_var _var_type;

                static LightSensors_DataWriter_ptr _duplicate (LightSensors_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LightSensors_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LightSensors_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LightSensors_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LightSensors_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LightSensors_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LightSensors_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LightSensors_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LightSensors_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LightSensors_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LightSensors_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LightSensors_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LightSensors_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LightSensors_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LightSensors_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LightSensors_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LightSensors_& instance_data) = 0;

            protected:
                LightSensors_DataWriter () {};
                ~LightSensors_DataWriter () {};
            private:
                LightSensors_DataWriter (const LightSensors_DataWriter &);
                LightSensors_DataWriter & operator = (const LightSensors_DataWriter &);
            };

            class  LightSensors_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LightSensors_DataReader_ptr _ptr_type;
                typedef LightSensors_DataReader_var _var_type;

                static LightSensors_DataReader_ptr _duplicate (LightSensors_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LightSensors_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LightSensors_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LightSensors_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LightSensors_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LightSensors_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LightSensors_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LightSensors_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LightSensors_& instance) = 0;

            protected:
                LightSensors_DataReader () {};
                ~LightSensors_DataReader () {};
            private:
                LightSensors_DataReader (const LightSensors_DataReader &);
                LightSensors_DataReader & operator = (const LightSensors_DataReader &);
            };

            class  LightSensors_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LightSensors_DataReaderView_ptr _ptr_type;
                typedef LightSensors_DataReaderView_var _var_type;

                static LightSensors_DataReaderView_ptr _duplicate (LightSensors_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LightSensors_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LightSensors_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LightSensors_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LightSensors_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LightSensors_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LightSensors_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LightSensors_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LightSensors_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LightSensors_& instance) = 0;

            protected:
                LightSensors_DataReaderView () {};
                ~LightSensors_DataReaderView () {};
            private:
                LightSensors_DataReaderView (const LightSensors_DataReaderView &);
                LightSensors_DataReaderView & operator = (const LightSensors_DataReaderView &);
            };
        }

    }

}

#endif
